from metadocker.cmdline.commands.base import Argument, SpecificCommand
from metadocker.common.errors import SimpleError
from metadocker.docker.driver import driver


class ShellCommand(SpecificCommand):
    NAME = "shell"
    HELP = "Lance un shell sur le contaeneur"
    ARGUMENTS = [
        Argument("--root", "-r", action="store_true", help="Lance avec utilisateur root"),
        Argument("shell", nargs="?", help="Le shell a executer", default="/bin/bash")
    ]

    def run(self, env):
        if not driver.is_running(name=env.docker.name):
            raise SimpleError(f"Le conteneur '{env.docker.name}' n'est pas lancé")


        driver.exec(env.docker.name, commande=self.shell, uid=0 if self.root else None, interactive=True, catch=False)

